Subject: Re: Saving to 32 bits of GPRs in signal context

From: Segher Boessenkool <[email-masked]>
Date: Wed, 30 May 2007 14:30:34 +0200

>> If what you're
>> saying is true in the 2.03 POWER ISA, even for server
>> class implementations, that would be very unfortunate.
>
> I believe Category:Server implementations are required to behave as 
> you expect.  Category:Embedded implementations may have different 
> behavior.  Like it or not, BookE *is* part of the Power architecture, 
> and there are going to be 64-bit implementations of BookE that we need 
> to take into account.

Sure.  How about we worry about this when support for
such CPUs is added _at all_ to Linux; for this issue,
the only required change would be to refuse the prctl()
call, right?

>> If you mean Book I 1.5.2, that is for embedded class
>> (i.e., BookE) CPUs only.
>
> I think that's exactly what Kumar's talking about. The assumption that 
> all 64-bit Power processors will use those upper bits in some 
> meaningful way is not valid.  Also, ld and std do not architecturally 
> "just work" on BookE implementations running in 32b mode.  Those 
> instructions are part of the 64-bit category in 2.03, and may illop on 
> BookE processors running in 32b mode.

Sounds like it will be a lovely effort to add support for
such CPUs to Linux.

Segher